package org.dive4elements.river.artifacts.services;

import org.w3c.dom.Document;

import org.apache.log4j.Logger;

import org.hibernate.Session;

import org.dive4elements.artifacts.CallMeta;
import org.dive4elements.artifacts.GlobalContext;

import org.dive4elements.artifactdatabase.XMLService;

import org.dive4elements.river.backend.SessionHolder;


public abstract class FLYSService extends XMLService {

    private static final Logger logger = Logger.getLogger(FLYSService.class);


    @Override
    public Document processXML(
        Document      data,
        GlobalContext globalContext,
        CallMeta      callMeta
    ) {
        init();

        try {
            return doProcess(data, globalContext, callMeta);
        }
        finally {
            shutdown();
        }
    }


    protected abstract Document doProcess(
        Document      data,
        GlobalContext globalContext,
        CallMeta      callMeta);


    protected void init() {
        logger.debug("init");
        SessionHolder.acquire();
    }


    protected void shutdown() {
        logger.debug("shutdown");
        Session session = SessionHolder.HOLDER.get();
        session.close();

        SessionHolder.release();
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
